Index: ./kaffe/kaffevm/systems/unix-jthreads/jthread.c
===================================================================
RCS file: /home/cvspublic/kaffe/kaffe/kaffevm/systems/unix-jthreads/jthread.c,v
retrieving revision 1.26
diff -u -r1.26 jthread.c
--- jthread.c	1998/10/19 20:18:54	1.26
+++ jthread.c	1998/11/10 15:09:48
@@ -579,6 +579,23 @@
 	}
 }
 
+
+static void
+handleTrace(void)
+{
+        jthread* tid;
+
+        for (tid = liveThreads; tid != NULL; tid = tid->nextlive) {
+		printf("tid %p, status %x flags %02x", tid, tid->status, tid->flags);
+		if (tid->blockqueue != NULL)
+		    printf(" blockqueue %p (%p)", tid->blockqueue, *tid->blockqueue);
+		if (tid->nextQ != NULL)
+		    printf(" nextQ %p", tid->nextQ);
+		printf("\n");
+        }
+}
+
+
 /*
  * handle an interrupt.
  * 
@@ -589,6 +606,10 @@
 handleInterrupt(int sig)
 {
 	switch(sig) {
+	case SIGUSR1:
+		handleTrace();
+		break;
+
 	case SIGALRM:
 		alarmException();
 		break;
@@ -792,6 +813,8 @@
 	catchSignal(SIGVTALRM, interrupt);
 	catchSignal(SIGALRM, interrupt);
 	catchSignal(SIGIO, interrupt);
+
+	catchSignal(SIGUSR1, interrupt);
 
 #if defined(SIGCHLD)
         catchSignal(SIGCHLD, interrupt);
Index: ./kaffe/kaffevm/locks.c
===================================================================
RCS file: /home/cvspublic/kaffe/kaffe/kaffevm/locks.c,v
retrieving revision 1.7
diff -u -r1.7 locks.c
--- locks.c	1998/08/26 21:30:14	1.7
+++ locks.c	1998/11/10 15:09:48
@@ -160,7 +160,14 @@
 		lk->count++;
 	}
 	else {
+		int trace = 0;
+		if (lk->count != 0) {
+		    printf("1 __lockMutex() lk %p count %d holder %p current %p\n", lk, lk->count, lk->holder, (*Kaffe_ThreadInterface.currentNative)());
+		    trace = 1;
+		}
 		(*Kaffe_LockInterface.lock)(lk);
+		if (trace)
+		    printf("2 __lockMutex() lk %p count %d holder %p current %p\n", lk, lk->count, lk->holder, (*Kaffe_ThreadInterface.currentNative)());
 		lk->count = 1;
 	}
 }
